/* @(#) cgksmeta.h  version:1.5  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.cgksmeta.h
 * SCCS id :	cgksmeta.h 1.5
 * Last edited:	11/9/84 14:16:09
 *
 * Author:	Miente Bakker
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */

/*
 * Introduction of new types for Metafiles 
 */

#ifdef VAXTYPE
typedef Int Itmtp;
#else
#define Itmtp unsigned
#endif

#ifdef METAFILE

/* definition of metafile header */

typedef struct Mfhdr {
	/* general information */
	char	mfh_GKSM[4];	/* string 'GKSM'; < 5 char. */
	char	mfh_N[40];	/* name of author, etc. ; 40 char.*/
	char	mfh_D[8];	/* date of issue ; 8 char. */
	Int	mfh_V;		/* version number ; < 100 */

	/* Field length specification */
	Int	mfh_H;		/* header length: 0,1,2,3 or 4 */
	Int	mfh_T;		/* length of item type indicator field*/
	Int	mfh_L;		/* lngth of itm lngth indicator field */
	Int	mfh_I;		/* length of field for each integer in
				 * the item (applies to all data
				 * marked (i) in the record description
				 */
	Int	mfh_R;		/* length of field for each real in
				 * the item (applies to all data
				 * marked (r) in the record description
				 */

	/* specification of number representation */
	Int	mfh_F;		/* format convention */
	Int	mfh_RI;		/* number representation for data
					marked (r)	*/
	Int	mfh_ZERO;	/* integer equivalent to 0., if
					Mf_RI = 2	*/
	Int	mfh_ONE;	/* integer equivalent to 1., if
					Mf_RI = 2	*/
	char	mfh_itmhf[20];	/* format of item header */
	char	mfh_intf[20];	/* integer format	*/
	char	mfh_realf[20];	/* real format		*/

	char	mfh_itmhdr[20];	/* item header string */
	Size	mfh_hdrlen;	/* item header size */

		} Mfhdr;
/*
 * Introduction of item header
 */
typedef struct {
	String	ih_gksm;	/* string 'GKSM' or part of it */
	Itmtp	ih_tp;		/* item identification (type) */
	Size	ih_lngth;	/* item data record length */
	}	Itemhead;
/*
 * Introduction of item 
 */
typedef struct Item {
	Itemhead	it_hdr;	/* item header */
	char *		it_data;/* pointer to item data record */
	} Item;

	/* Metafile driver */
typedef struct Mf_screen {
	Bool (*m_hdr)	();	/*	metafile header	*/
	Bool (*m_clwk)	();	/*end item	*/
	Bool (*m_clrwk)	();	/*clear workstation	*/
	Bool (*m_rsgwk)	();	/*redraw all segments on w.s.	*/
	Bool (*m_uwk)	();	/*update w.s.	*/
	Bool (*m_sds)	();	/*set deferral state	*/
	Bool (*m_msg)	();	/*message	*/
	Bool (*m_esc)	();	/*escape	*/

	Bool (*m_pl)	();	/*polyline	*/
	Bool (*m_pm)	();	/*polymarker	*/
	Bool (*m_tx)	();	/*text	*/
	Bool (*m_fa)	();	/*fill area	*/
	Bool (*m_ca)	();	/*cell array	*/
	Bool (*m_gdp)	();	/*general drawing primitive	*/

	Bool (*m_spli)	();	/*set polyline index	*/
	Bool (*m_sln)	();	/*set line type	*/
	Bool (*m_slwsc)	();	/*set linewidth scale factor	*/
	Bool (*m_splci)	();	/*set polyline colour index	*/
	Bool (*m_spmi)	();	/*set polymarker index	*/
	Bool (*m_smk)	();	/*set marker type		*/
	Bool (*m_smksc)	();	/*set marker size scale factor	*/
	Bool (*m_spmci)	();	/*set marker colour index	*/
	Bool (*m_stxi)	();	/*set text index	*/
	Bool (*m_stxfp)	();	/*set text font and precision	*/
	Bool (*m_schxp)	();	/*set character expansion factor*/
	Bool (*m_schsp)	();	/*set character spacing	*/
	Bool (*m_stxci)	();	/*set text colour index	*/
	Bool (*m_schup)	();	/*set character up vector	*/
	Bool (*m_stxp)	();	/*set text path	*/
	Bool (*m_stxal)	();	/*set text alignment	*/
	Bool (*m_sfai)	();	/*set fill area index	*/
	Bool (*m_sfais)	();	/*set fill area interior style	*/
	Bool (*m_sfasi)	();	/*set fill area style index	*/
	Bool (*m_sfaci)	();	/*set fill area colour index	*/
	Bool (*m_spa)	();	/*set pattern size	*/
	Bool (*m_sparf)	();	/*set pattern ref pt */
	Bool (*m_sasf)	();	/*set ASPECT SOURCE FLAGs	*/
	Bool (*m_spkid)	();	/*set pick identifier	*/

	Bool (*m_splr)	();	/*set poyline representation	*/
	Bool (*m_spmr)	();	/*set polymarker representation	*/
	Bool (*m_stxr)	();	/*set text representation	*/
	Bool (*m_sfar)	();	/*set fill area representation	*/
	Bool (*m_spar)	();	/*set pattern representation	*/
	Bool (*m_scr)	();	/*set colour representation	*/

	Bool (*m_sclpr)	();	/*set clipping rectangle	*/
	Bool (*m_swkwn)	();	/*set workstation window	*/
	Bool (*m_swkvp)	();	/*set workstation viewport	*/

	Bool (*m_crsg)	();	/*create segment	*/
	Bool (*m_clsg)	();	/*close segment	*/
	Bool (*m_rensg)	();	/*rename segment	*/
	Bool (*m_dsg)	();	/*delete segment	*/

	Bool (*m_ssgt)	();	/*set segment transformation	*/
	Bool (*m_svis)	();	/*set segment visibility	*/
	Bool (*m_shlit)	();	/*set segment highlighting	*/
	Bool (*m_ssgp)	();	/*set segment priority	*/
	Bool (*m_sdtec)	();	/*set segment detectability	*/
	} Mf_screen;

#else /* METAFILE not defined */
typedef struct {
	Int mf_dummy;
	} Mf_screen;
typedef struct {
	Int hd_dummy;
	} Mfhdr;
typedef struct {
	Int ith_dummy;
	} Itemhead;
typedef struct {
	Int it_dummy;
	} Item;

#endif /* METAFILE */
