/* @(#) cgks.h  version:1.20  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.cgks.h
 * SCCS id :	cgks.h 1.20
 * Last edited:	11/13/84 12:30:48
 *
 * Author:	Paul ten Hagen, David Rosenthal, Behr de Ruiter,
 *		Miente Bakker
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */


#define	File	FILE /*type FILE defined in /usr/include/stdio.h */

typedef (*Fun)(); /*function pointer*/
/*typedef (*Fun)(); /*delete this rule*/

typedef char *String;

#ifdef ENUM
typedef enum { FALSE, TRUE } Bool;
#else
#define FALSE	0
#define TRUE	1
#define Bool unsigned
#endif

#ifdef VAXTYPE
typedef unsigned Int;
typedef float Real;
#else
#define Int unsigned
#define Real float
#endif

typedef Real Tmat[2][3];

typedef struct {
	Real	d_x, d_y;
	} Dc;	/*device coordinate */
typedef struct {
	Int 	i_x, i_y;
	} Ic;	/*integer coordinates*/
typedef struct {
	Dc	d_ll, d_ur
	} Drect; /*device rectangle(viewport) */
typedef struct {
	Ic	i_ll, i_ur;
	} Irect;
typedef struct {
	Real	w_x, w_y;
	} Wc;	/* world coordinates */
typedef	struct {
	Real	n_x, n_y;
	} Nc;	/* normalized device coordinate */
typedef struct {
	Wc	w_ll, w_ur;
	} Wrect; /* rectangle in world coordinates (window)*/
typedef struct {
	Nc	n_ll, n_ur;
	} Nrect; /* rectangle in NDC coordinates.
		  * viewport in normaliz. transformation, or
		  * window in workstation transformation
		  */
typedef struct {
	Wrect	nt_wind;
	Nrect	nt_view;
	} Ntran; /* normalization transformation.
		  * characterized by its window and viewport
		  */
 

#ifdef ENUM
typedef enum {
	/* Implementation dependent, for example */ 
	CIRCLE, ARC
	}  Gdpi;
#else
#define Gdpi unsigned
#define CIRCLE 0
#define ARC 1
#endif

typedef struct {
	Gdpi	gd_id;
	Int	gd_satt; /*between 0 and 017 octal; a bit each for */
			 /*POL, POM, TXT and FAR */
	} Gdp;

#ifdef VAXTYPE
typedef	char	*Grecord; 
#else
#define Grecord char *
#endif
 	/* Record containing information for a Gdp.
	 * Size and contents are gdp dependent.
	 * See g_draw().
	 */

typedef struct {
	Int	as_xsz;
	Int	as_ysz;
	} ArrSiz;/*for inquire pixel */

typedef struct {
	Real	c_red, c_green, c_blue;
	} Colour;

#ifdef VAXTYPE
typedef Int Size;
#else
#define Size unsigned
#endif

typedef struct {
	Real er_dummy;
	} Erarea;
	/* Area for error recording, used by the error function.
	 * Implementation dependent, and not yet used
	 * (Include a wtype and an area (?) )
	 */

#ifdef VAXTYPE
typedef Int Ercode;
#else
#define Ercode unsigned
#endif

/*
 * Implementation dependent types for escape function:
 */
typedef union {
	/* selective bitplane manipulation: */
	struct {
		Int sbm_wbitmask; /*mask for selective bitplane write*/
		} sbm_rec;
	/* transparancy: */
	struct {
		Bool trp_onoff;
		} trp_rec;
	} Es_data;

	/* Implementation dependent escape function identifier:
	 * for example:
	 */
#ifdef ENUM
typedef enum {
	ES_SELWBPL,	/*selective write in bit planes */
	ES_TRANSPARENT,
	}  Es_func;
#else
#define Es_func unsigned
#define ES_SELWBPL 0
#define ES_TRANSPARENT 1
#endif


#ifdef VAXTYPE
typedef Int Bindex;
#else
#define Bindex unsigned
#endif

#ifdef VAXTYPE
typedef Int Cindex;
#else
#define Cindex unsigned
#endif

typedef Int Asflags;

/******Polyline representations******/

#ifdef VAXTYPE
typedef Int Ltype;
typedef Real Lwidth;
#else
#define Ltype unsigned
#define Lwidth float
#endif

typedef struct {
	Bindex	lr_ix;
	Ltype	lr_lt;
	Lwidth	lr_lw;
	Cindex	lr_ci;
	} LineRep;

/******Polymark representations******/

#ifdef VAXTYPE
typedef Real Msize;
typedef Int Mtype;
#else
#define Msize float
#define Mtype unsigned
#endif

typedef struct {
	Bindex	mr_ix;
	Mtype	mr_mt;
	Msize	mr_ms;
	Cindex	mr_ci;
	} MarkRep;

/******text representations******/

#ifdef VAXTYPE
typedef Real Charef;
typedef Real Charht;
typedef Real Charsp;
#else
#define Charef float
#define Charht float
#define Charsp float
#endif

typedef struct {
	Real ch_dummy;
	} Chfatt;

#ifdef VAXTYPE
typedef Int Tfont; /* not a String"?*/
#else
#define Tfont unsigned
#endif

#ifdef ENUM
typedef enum { STR, CHAR, STROKEP } Tprec;
typedef enum { RIGHT, LEFT, UP, DOWN } Path;
typedef	enum { HNORMAL, ALEFT, CENTRE, ARIGHT } Talhor;
typedef	enum { VNORMAL, TOP, CAP, HALF, BASE, BOTTOM } Talver;
#else
#define Tprec	unsigned
#define Path	unsigned
#define Talhor	unsigned
#define Talver	unsigned
#define STR	0
#define CHAR	1
#define STROKEP	2
#define RIGHT	0
#define LEFT	1
#define UP	2
#define DOWN	3
#define HNORMAL	0
#define ALEFT	1
#define CENTRE	2
#define ARIGHT	3
#define VNORMAL	0
#define TOP	1
#define CAP	2
#define HALF	3
#define BASE	4
#define BOTTOM	5
#endif

typedef	struct {
	Talhor	ta_hor;
	Talver	ta_ver;
	} Talign;
typedef struct {
	Tfont fp_fo;
	Tprec fp_pr;
	} FoPr;
typedef struct {
	Bindex	tx_ix;
	FoPr	tx_fp;
	Charef	tx_chef;
	Charsp	tx_chsp;
	Cindex	tx_ci;
	} TextRep;

/******pattern representations******/

typedef struct {
	Bindex	pa_ix;
	Int	pa_n, pa_m;
	Cindex	*pa_ci;
	} PattRep;

/******fillarea representations******/

#ifdef VAXTYPE
typedef Int Sindex;
#else
#define Sindex unsigned
#endif

#ifdef ENUM
typedef enum { HOLLOW, SOLID, PATTERN, HATCH } Istyle;
#else
#define Istyle unsigned
#define HOLLOW	0
#define SOLID	1
#define PATTERN	2
#define HATCH	3
#endif

typedef struct {
	Bindex	fa_ix;
	Istyle  fa_is;
	Sindex	fa_si;
	Cindex	fa_ci;
	} AreaRep;

/*************segment typedefs**************/

#ifdef VAXTYPE
typedef Int Segname;
typedef Real Segpri;
#else
#define Segname unsigned
#define Segpri  float
#endif

typedef	struct BHEAD{
	Int 	sb_typ;
	Size	sb_sz;
	struct BHEAD	*sb_link;	
	} Bhead;

typedef struct Wss *Wssptr;

typedef	struct {
	Segname	sg_sn;
	/*Wssegp	*sg_ws;/*field not used*/
	Wssptr	*sg_onws;
	Tmat	sg_mat;
	Bool	sg_vis;
	Bool	sg_hil;
	Segpri	sg_pri;
	Bool	sg_det;
	Bhead	*sg_firstbh;
	Bhead 	*sg_lastbh;
	}	Seg;

typedef struct SEGINST {
	struct SEGINST	*si_next;
	struct SEGINST	*si_prev;
	Seg		*si_this;
	} Seginst;

/********************input typedefs************************/
typedef struct {
	Ntran	*loc_nt;
	Wc	loc_pt;
	} Locate;

typedef struct {
	Ntran	*stk_nt;
	Int	stk_no;
	Wc	*stk_pt;
	} Stroke;

#ifdef VAXTYPE
typedef Real Value;
typedef Int Choice;
typedef Int Pickid;
#else
#define Value float
#define Choice unsigned
#define Pickid unsigned
#endif

typedef struct {
	Seg	*pik_seg;
	Pickid	pik_pid;
	} Pick;
typedef union {
	Locate	ev_loc;
	Stroke	ev_stk;
	Value	ev_val;
	Choice	ev_cho;
	Pick	ev_pik;
	String	ev_str;
	} Idata;

#ifdef ENUM
typedef enum {LOCATOR, STROKE, VALUATOR, CHOICE, PICK, STRING } Iclass;
#else
#define Iclass unsigned
#define LOCATOR	0
#define STROKE	1
#define VALUATOR 2
#define CHOICE	3
#define PICK	4
#define STRING	5
#endif

#ifdef VAXTYPE
typedef Int Devno;
#else
#define Devno unsigned
#endif

#ifdef VAXTYPE
typedef Int Pet;
#else
#define Pet unsigned
#endif

#ifdef ENUM
typedef enum { REQUEST, EVENT, SAMPLE } Imode;
#else
#define Imode unsigned
#define REQUEST 0
#define EVENT	1
#define SAMPLE	2
#endif

typedef union {
	struct { /* locator fields*/
		Cindex	loc_col;
		} loc_rec;
	struct { /* stroke fields*/
		Cindex	stk_col;
		} stk_rec;
	struct { /*valuator fields*/
		Real	val_max, val_min;
		Cindex	val_col;
		} val_rec;
	struct { /*choice record*/ 
		Int	cho_nr;
		String	*cho_str;
		Int	*cho_nrs;
		Cindex	cho_col;
		} cho_rec;
	struct { /* pick record*/
		Real	pik_rat;
		Cindex	pik_col;
		} pik_rec;
	struct { /*string record*/
		Size	str_size, str_posn;
		Cindex	str_col;
		} str_rec;
	} Drecord;

typedef struct {
	Iclass	id_clas;
	Imode	id_mode;
	Bool	id_echo;
	Idata	id_ival;
	Pet	id_pet;
	Drect	id_area;
	Drecord	id_drec;
	} Idevice;

typedef struct {
	Idevice	idd_idev;
	Int	idd_npet;
	Pet	*idd_pets;
	} Iddescr;

/*
 ******************driver field*******************************
 *
 * Type Screen is the DI/DD interface in our implementation.
 * This type originates from the GIGO package, and contains some
 * fields that are not used in the GKS implementation
 * at the moment (s_flag, s_timo, s_code, s_hit).
 * These fields might disappear in the future
 */
typedef struct {
	Ic	s_size;
	Ic	s_chsz;
	Int	s_chht;
	Ic	s_hit;
	int	s_code;
	Cindex	s_ccol;
	char	s_flag;
	char	s_timo;
	Bool	(*s_tera)(); /*open ws; total erase(clear ws)*/
	Bool	(*s_eral)(); /*set line erase mode*/
	Bool	(*s_clos)(); /*close workstation*/
	Bool	(*s_clpr)(); /*set clip rectangle*/
	Bool	(*s_msge)(); /*send a message to the screen*/
	Bool	(*s_escp)(); /*escape features */

	Bool	(*s_line)(); /*linepieces*/
	Bool	(*s_mark)(); /*markers*/
	Bool	(*s_char)(); /*hard characters*/
	/*Bool	(*s_scan)(); /*raster scan for fillarea*/
	Bool	(*s_pxst)(); /*pixels (all pixs same or different) */
	Bool	(*s_runl)(); /*pixels via a run length encoding*/
	Bool	(*s_cell)(); /*directly cellarray to device*/
	Bool	(*s_gdpr)(); /*gen draw prim*/
	Bool	(*s_rect)(); /*use it as rect erase for teklike term*/

	Bool	(*s_latt)(); /*set polyline attributes*/
	Bool	(*s_matt)(); /*set polymarker attributes*/
	Bool	(*s_tatt)(); /*set text attributes*/
	Bool	(*s_fatt)(); /*set fillarea attributes*/
	Bool	(*s_colr)(); /*select colour */
	Bool	(*s_colt)(); /*set colour table*/

	Bool	(*s_ipix)(); /*inquire pixel and inq pixel array*/
#ifndef	HIGH_INPUT /*for a simple device, with only request input:*/
	int	(*s_inpc)(); /*get input from cursor (location) */
	int	(*s_inpk)(); /*get input from keyboard (character)*/
#else
	Bool	(*s_idev)(); /*init loc,val,cho,pik,str or stk inp dev*/
	Bool	(*s_sdev)(); /*set loc,val,cho,pik,str or stk idev mod*/
	/* in the following 6 entries the returned Bool value is the
	 * returned status for REQUEST input. 
	 * (for SAMPLE input this value is not used/interpreted)
	 */
	Bool	(*s_inlc)(); /*get req. or sample input from loc dev */
	Bool	(*s_invl)(); /*get req. or sample input from val dev */
	Bool	(*s_inch)(); /*get req. or sample input from cho dev */
	Bool	(*s_inst)(); /*get req. or sample input from str dev */
	Bool	(*s_insk)(); /*get req. or sample input from stke dev */
	Bool	(*s_inpk)(); /*get req. or sample input from pick dev */
	Bool	(*s_wait)(); /*await event*/
#endif
	Bool	(*s_hili)(); /*hilite output primitive*/
	} Screen;

/**********************statelists******************************/
/*
 * some forward definitions
 */
typedef struct Gksi	*Gksiptr;
typedef struct Gks	*Gksptr;
typedef struct Mf_screen	*Mf_scrnptr;
typedef struct Item	*Itemptr;
typedef struct Mfhdr	*Mfhdrptr;

typedef struct {
	Int	wi_attm;
	LineRep	wi_lrep;
	MarkRep	wi_mrep;
	AreaRep	wi_frep;
	TextRep wi_trep;
	PattRep *wi_prep; 
	/*PattRep wi_prep; not neccessary because the info in this
	 *representation is not subject to local or global flags,
	 *so can be taken directly from the gks statelist via a ptr.
	 */
	Dc	wi_chvec; /*height vector of char box */
	Dc	wi_cwvec; /*width vector of char box */
	Dc	wi_cspvec; 
		/*a vector parallel to wi_cwvec, however with correct
		 *length, being a fraction of wi_cwvec
		 */
	Dc	wi_xpatsiz;
	Dc	wi_ypatsiz;
	Dc	wi_patref;
	Tmat	wi_mat;    /*workstation transf matrix*/
	Tmat 	*wi_sgmat;
		/*pointer to segment-matrix in drawsegonws(), and to 
		 *combination of segment-matrix and insert-matrix
		 *in insseg(). outside these funcs field is not used.
		 */
	Drect	wi_clipr;
#ifdef METAFILE
/*
*	some extra field for metafiles :
*/
	Mfhdrptr wi_mfhdr;	/* pointer to metafile header	*/
	Itemptr	wi_item;	/* ptr to item last read */
	Bool	wi_miend;	/* Boolean to denote MI's end	*/
	Gksptr	wi_gkss;	/* pointer to Gks Statelist relative
				 * to workstation of cat MI 
				 */
	Gksiptr	wi_gksis;	/* pointer to Gks Internal Statelist
				 * relative to workstation of cat MI
				 */
#endif
	} Wsis;

#ifdef ENUM
typedef enum { ASAP, BNIL, BNIG, ASTI } Defmode;
#else
#define Defmode unsigned
#define ASAP	0
#define BNIL	1
#define BNIG	2
#define ASTI	3
#endif

typedef	struct {
/*some more fields must be added*/
/*wc*/	Int	wd_cat;  /* ws category */
/*wr*/	Int	wd_rov;  /* raster or vector display*/
/*  */	Screen	*wd_screen;  /*can be seen as type field*/
/*  */	Mf_scrnptr wd_mfscrn; /*can be seen as type field for MO*/

/*dr*/	Int	wd_dmar; /*dyn mod acc for repr's and tr*/
			 /*each repr/tr is represented by 1 bit */
/*ds*/	Int	wd_dmas; /*dyn mod acc for seg attr */
/*df*/	Defmode	wd_defr;
/*dw*/	Bool	wd_waitr;/*TRUE=SUPPRESSED;FALSE=ALLOWED*/

/*xs*/	Drect	wd_maxsurf;

/*ln*/	Int	wd_nltyp;
/*lt*/	Ltype	*wd_ltyp;
/*lm*/	Int	wd_nlwth;
/*lw*/	Lwidth	*wd_lwth;
/*li*/	Int	wd_nline;
/*lr*/	LineRep *wd_line;

/*mn*/	Int	wd_nmktyp;
/*ma*/	Mtype	*wd_mktyp;
/*ms*/	Int	wd_nmksz;
/*mz*/	Msize	*wd_mksz;
/*mi*/	Int	wd_nmark;
/*mr*/	MarkRep *wd_mark;

/*tf*/	Int	wd_nfopr;
/*tp*/	FoPr	*wd_fopr;
/*te*/	Int	wd_nchef;
/*tx*/	Charef	*wd_chef;
/*tn*/	Int	wd_nchht;
/*th*/	Charht	*wd_chht;
/*ti*/	Int	wd_ntext;
/*tr*/	TextRep *wd_text;

/*fs*/	Int	wd_nistyl;
/*ft*/	Istyle	*wd_istyl;
/*fh*/	Int	wd_nhatst;
/*fc*/	Sindex	*wd_hatst;
/*fi*/	Int	wd_narea;
/*fr*/	AreaRep *wd_area;

/*pi*/	Int	wd_npatt;
/*pr*/	PattRep	*wd_patt;

/*cx*/	Int	wd_ncix;
/*ca*/	Bool	wd_colav;
/*cn*/	Int	wd_ncol;
/*cc*/	Colour	*wd_col;

/*gn*/	Int	wd_ngdp;
/*gg*/	Gdp	*wd_gdp;

		/*6 fields to store nr of available i-devices:*/
		/*(not in report 7.2)*/
/**n*/	Int	wd_ndevs[6];	/* * is one of aoueyi */
/**d*/	Iddescr	*wd_ddesc[6];	/* * is one of aoueyi */
}	Wsd;

typedef struct Wss {
	Wsd	*ws_wsd;
	Wsis	*ws_wsis;
/*
 *	next field proposed by Miente according to ISO/DIS 7942
 * 	ch. 6.5	this field is needed for a convenient use of the
 *	C-FORTRAN interface
 */
	Int	ws_id;	/* workstation identifier */

	File	*ws_ifile; /*connection identifier; infile */
	File	*ws_ofile; /*connection identifier; outfile */

	Bool	ws_actv;
	Seginst	*ws_segs; /* first inst has lowest prio;
		             ws_segs->si_next has higher prio */

	Defmode	ws_defr;  /*deferral mode*/
	Bool	ws_waitr; /*implicit reg. m. ;if wait then reg. suppr*/
			  /*so SUPPRESSED=TRUE*/
	Bool	ws_empty; /*display surface empty*/
	Bool	ws_newfr; /*new frame action necess. at update */

	Bool	ws_trupd; /*ws transf update st;NOTPENDING=FALSE */
	Nrect	ws_reqw;
	Nrect	ws_curw;
	Drect	ws_reqv;
	Drect	ws_curv;

	Int	 ws_nline;
	LineRep *ws_line;
	Int	 ws_nmark;
	MarkRep *ws_mark;
	Int	 ws_ntext;
	TextRep *ws_text;
	Int	 ws_narea;
	AreaRep *ws_area;
	Int	 ws_npatt;
	PattRep *ws_patt;

	Int	 ws_ncolr;
	Colour  *ws_colr;
	Idevice	*ws_devs[6];
	} Wss;

#ifdef GKS6
typedef struct {
	Wss	*ev_ws;
	Devno	ev_devn;
	Iclass	ev_class;
	Idata	ev_data;
	} Event;
#endif GKS6

#ifndef TRMTYP
/*definition of TRMTYP only in drivers that don't use following def's*/
typedef struct {
	char	op_lev, ip_lev;
	} GksLevl;

typedef struct {
	GksLevl	gd_lev;
	Int	gd_nrwt;
	String	*gd_avwt;
	Int	gd_nopws;
	Int	gd_nactv;
	Int	gd_nwsas;
	Int	gd_nntran;
	} Gksd;

#if	(GKS == 1 || GKS == 10)
typedef	struct {
	Bool	ge_erstate;
	Ercode	(*ge_erh)();
	/*to be extended*/
	} Gkse;
#endif

#ifdef ENUM
typedef enum { GKCL, GKOP, WSOP, WSAC, SGOP } GksState;
#else
#define GksState unsigned
#define ASFlag	unsigned
#define GKCL	0
#define GKOP	1
#define WSOP	2
#define WSAC	3
#define SGOP	4
#endif

typedef struct Gks {
	Ntran	**gk_ntran;
	Ntran   *gk_curnt;

	Asflags	gk_asf;
	Bindex	gk_line;
	Ltype	gk_lrlt;
	Lwidth	gk_lrlw;
	Cindex	gk_lrci;

	Bindex	gk_mark;
	Mtype	gk_mrmt;
	Msize	gk_mrms;
	Cindex	gk_mrci;	

	Bindex	gk_text;
	FoPr	gk_txfp;
	Charef	gk_chef;
	Charsp	gk_chsp;
	Cindex	gk_txci;	
	Charht	gk_chht;
	Wc	gk_chup;
	Path	gk_path;
	Talign	gk_txal;

	Bindex	gk_area;
	Istyle	gk_fais;
	Sindex	gk_fasi;	
	Cindex	gk_faci;

	Wc	gk_patsiz;
	Wc	gk_patref;
	Wss	**gk_opws;
	Wss	**gk_actv;
	Seg	*gk_opsg;
	Seginst	*gk_segs; /* gk_segs->si_this has lowest prio;
			     gk_segs->si_next has higher prio */
	Pickid	gk_pikid;
	Bool	gk_clip;
	Bool	gk_more;
	} Gks;
typedef struct Gksi {
	Wsd	**gki_wsd;
	Nc	gki_chvec;  /*character height vector*/
	Nc	gki_cwvec;  /*character width vector; whithout
			     *interpretion of the char exp. factor
			     */
	Nc	gki_xpatsiz;/*pattern size (SX part), 
			     *transformed by at least norm.tr.*/
	Nc	gki_ypatsiz;/*pattern size (SY part), 
			     *transformed by at least norm.tr.*/
	Nc	gki_patref; /*pattern ref pt, transf by (at least) NTR*/
	Tmat 	gki_mat;
	Tmat	gki_imat;
	Int	*gki_ntp;
	Bool	gki_sgact;/*implementation added state:segment active*/
	} Gksi;
#endif


/*
typedef struct {
	Segname	se_name;
	Bool	se_visb;
	Bool	se_detc;
	Bool	se_hilt;
	Segpri	se_prio;
	wssptr	*se_onws; 
	Tmat	se_tran;
	} Seg2;
*/
