/*
 * this program draws one cellarray,
 * puts it in a segment, and redraws the segment several times
 * each time with a different segment transformation
 */

#include "cgksincl.h"

	Gks	*gkss;
	Wss	*wss_aed;
	Int 	n, i, k, number, m;
	Real	r,pi, th;
	Wc	*p1, *p2;
	AreaRep	fa;
	LineRep	lr;
	TextRep	tr;
	String	string;
	Tmat	segmat;
	Seg	*seg;

	Drect	drect0  = {  40,   25, 470, 455};
	Nrect	nrect2 = { 0.0, 0.0, 1.0, 1.0};
	Wrect	wrect = {0.0, 0.0, 1.0, 1.0},  wrectp;
	Colour	col, bg_col = {0.7, 0.7, 0.1}, 
		yellow 	  ={1.0, 1.0, 0.0},
		white_col ={1.0, 1.0, 0.8};
	Cindex	*ci;

set_pl_rect(wr)
Wrect	*wr;
{	p2 = p1;
	p2->w_x = wr->w_ll.w_x; p2->w_y = wr->w_ll.w_y; p2++;
	p2->w_x = wr->w_ll.w_x; p2->w_y = wr->w_ur.w_y; p2++;
	p2->w_x = wr->w_ur.w_x; p2->w_y = wr->w_ur.w_y; p2++;
	p2->w_x = wr->w_ur.w_x; p2->w_y = wr->w_ll.w_y; p2++;
	p2->w_x = wr->w_ll.w_x; p2->w_y = wr->w_ll.w_y;
}

main()
{
	gkss    = open_gks(NULL, NULL, NULL, "mess13");
	wss_aed = open_ws(NULL, NULL, aed512);
	activate(wss_aed);

	setdrect(wss_aed, &drect0, 40.0, 25.0, 470.0, 455.0);

	col_rep(wss_aed,   0, &bg_col);
	col_rep(wss_aed, 255, &white_col);
	col_rep(wss_aed, 254, &yellow);

	lr.lr_lt = SOLIDL;
	if (wss_aed->ws_wsd->wd_screen->s_colr) fa.fa_is = SOLID;
	else fa.fa_is = HOLLOW;

	number = 15; r = 15.0;

	pi = 3.141;
	for (i=1; i<250; i = i +1) {
		col.c_red  =(sin(2*i*pi/255.0       )+1.0)/2.0;
		col.c_green=(sin(2*i*pi/255.0+2*pi/3)+1.0)/2.0;
		col.c_blue =(sin(2*i*pi/255.0+4*pi/3)+1.0)/2.0;
	     	col_rep(wss_aed, i, &col);

	     	lr.lr_ci = i; 
	     	lr.lr_ix = i; 
	     	pl_rep(wss_aed, &lr);
	     	fa.fa_ci = i;
	     	fa.fa_ix =  i ; fa_rep(wss_aed, &fa);
	}

	s_pl_i(5);

	s_w_wind(wss_aed, &nrect2);
	s_w_view(wss_aed, &drect0);
	update(wss_aed, TRUE);

	n = 200;
	CALLOC(p1, Wc, n, 0)

	k = 3;
	s_window  (gkss->gk_ntran[k], &wrect);
	s_viewport(gkss->gk_ntran[k], &nrect2);
	sel_cntran(gkss->gk_ntran[k]);

	set_pl_rect(&wrect);
	s_pl_i(12);
	polyline(5, p1);

	wrectp.w_ll.w_x = 0.05;
	wrectp.w_ll.w_y = 0.5 ;
	wrectp.w_ur.w_x = 0.55;
	wrectp.w_ur.w_y = 0.88;
	n = 10; m = 13;
	CALLOC(ci, Cindex, n*m, 0)

	for (i = 0; i < n*m; i++) ci[i] = (7 * i * i + 4) % 255;

	seg = newseg(1);
	cellarray(&wrectp, n, m, ci);
	closeg();

	p2 = p1; p2->w_x = 0.0; p2->w_y = 0.0;
	p2++;    p2->w_x = 1.0; p2->w_y = 0.0;
	p2++;    p2->w_x = 1.0; p2->w_y = 0.06;
	p2++;    p2->w_x = 0.0; p2->w_y = 0.06;
	p2++;    p2->w_x = 0.0; p2->w_y = 0.0;

	s_w_wind(wss_aed, &nrect2);
	update(wss_aed, TRUE);

	s_fa_i(6);
	fillarea(4, p1);

	string = "Test for cellarray and segment transformation";
	p1->w_x = 0.03;
	p1->w_y = 0.024;
	s_ch_ht(0.03);
	tr.tx_ci = 160;
	tr.tx_chef = 1.0;
	tr.tx_ix = 2;
	tr.tx_fp.fp_fo = 1;
	tr.tx_fp.fp_pr = STR;
	tr.tx_ix =  2 ; tx_rep(wss_aed,&tr);
	s_tx_i(2);
	text(string, p1);

	redraw(wss_aed);

	th = 0.2;
	segmat[0][0] = cos(th);  
	segmat[0][1] = 2.9 * sin(th);
	segmat[0][2] = -th;
	segmat[1][0] = -sin(th); 	
	segmat[1][1] = cos(th); 
	segmat[1][2] = 0.0;
	transeg(seg, &segmat[0][0]);
	redraw(wss_aed);

	th = 0.4;
	segmat[0][0] = cos(th);  
	segmat[0][1] = 2.9 * sin(th);
	segmat[0][2] = -th;
	segmat[1][0] = -sin(th); 	
	segmat[1][1] = cos(th); 
	segmat[1][2] = 0.0;
	transeg(seg, &segmat[0][0]);
	redraw(wss_aed);

	deactivate(wss_aed);
	close_ws(wss_aed);
	close_gks();
}

setdrect(ws, dr, llx, lly, urx, ury)
Wss	*ws;
Drect	*dr;
Real	llx, lly, urx, ury;
{
	Drect	maxsurf;

	ASS(maxsurf , ws->ws_wsd->wd_maxsurf)
	dr->d_ll.d_x = llx * maxsurf.d_ur.d_x / 511.0; 
	dr->d_ll.d_y = lly * maxsurf.d_ur.d_y / 482.0; 
	dr->d_ur.d_x = urx * maxsurf.d_ur.d_x / 511.0; 
	dr->d_ur.d_y = ury * maxsurf.d_ur.d_y / 482.0; 
}

