/* This file together with the files sepp2util.c and sepp2var.c */
/* and sepp2cases.c                                             */
/* form a  GKS application to check (most of ) the available    */
/* GKS routines. Some of the statements below are not allowed   */
/* in an application. However the inquiry functions that will do*/
/* there tasks was not yet available.                           */
/* The program was written over a period of several months.     */
/* It has been extended each time a new part of GKS was         */
/* implemented.  It is therefore not a good example of a         */
/* nice GKS program.                                            */

/*#define PET_RUBBERBAND/* */

#include "cgksincl.h"
#include "inquire.h"

#define flagsglobal() s_asflags(017777)
#define	flagslocal() s_asflags(0)

Bool	coord_in_rect();
Real	s_raty();

extern	Gks	*gkss;

extern	Wss	*wss_aed;
extern	Int 	i, j, k, l;
extern	Int	lastcase;
extern	Size	p_nr, lastnr;	


extern	Real	rat, scalef;
extern	Real	ch_y, O_x, O_y, xrat, yrat;
extern	String	str, stringtx, errorstr;
extern 	char 	strchar[];

extern	String 	c[];
extern	String 	segmtx[8] ;

extern	Segname	segnm;
extern	Segpri	prio;
extern 	Seginst	*si;
extern 	Tmat	sg_mat;
extern	Bool	ok,force, frstforce, attsel, not_in;
extern	Int	lastk, lastattshown, colchange;
extern	Real	ytmp;
extern	Cindex 	cx;
extern	Ltype	lt;
extern	FoPr	fp;
extern 	Real	dev[13];
extern	Wc	*p1, *p2;
extern	Wc	p_tr0, p_tr1;
extern	Wrect	wrect4, wrect[];
extern	Wrect	wrectur, wrectot;
extern	Nrect	nrect[], nunit;

extern	Locate	loc0, loctx;
extern 	Pet 	pet;
extern	Drect	drectpri, drect0, drect1, drecttx;
extern	Drect	maxsurf;
extern	Drecord	drecpri, drec0, drec2, drectx;
extern	Value	valprio;
extern	Bool	ul;

extern	File	*aed_in , *aed_out ;

main(argc, argv)
int	argc;
char	*argv[];
{
	gkss    = open_gks(NULL, NULL, NULL,"messep2");

	s_if_of(argc, argv);
	wss_aed = open_ws(aed_in, aed_out, t4014);

	activate(wss_aed);

	/*transform 1 to 6 are for filltype selection */
	inst_transf(29);
	/*now trans 1 has highest prio; total order is
	  1,2,3,4,5,6,7,17,8,9,10,11,12,13,14,15,16,18,19,
	  20,21,22,23,24,25,26,27,28,29,0 */ 

	/*next rules actually not allowed in a user application*/
	ch_y = (Real)wss_aed->ws_wsd->wd_screen->s_chsz.i_y /
	       (Real)wss_aed->ws_wsd->wd_screen->s_size.i_y;
	for (i = 1; i < 5; i++) s_pc(i, ch_y);

	wrect4.w_ll.w_x = 0.01;   wrect4.w_ll.w_y = 0.00;
	wrect4.w_ur.w_x = 0.8001; wrect4.w_ur.w_y = 0.005 + 4.0 * ch_y;

	set_reps(wss_aed);

	CALLOC(p1, Wc, 200, MAIN)
	
	ASS(maxsurf , wss_aed->ws_curv)
	ASS(drect0 , maxsurf)
	if ((maxsurf.d_ur.d_x - maxsurf.d_ll.d_x) >
	    (maxsurf.d_ur.d_y - maxsurf.d_ll.d_y))
	       maxsurf.d_ur.d_x = maxsurf.d_ll.d_x +
	       maxsurf.d_ur.d_y - maxsurf.d_ll.d_y;
	xrat = (maxsurf.d_ur.d_x - maxsurf.d_ll.d_x) / 100.0;
	yrat = (maxsurf.d_ur.d_y - maxsurf.d_ll.d_y) / 100.0;
	O_x = maxsurf.d_ll.d_x;
	O_y = maxsurf.d_ll.d_y;
	drect1.d_ll.d_x = O_x + 1.0 * xrat;
	drect1.d_ll.d_y = O_y + 22.0 * yrat;
	drect1.d_ur.d_x = O_x + 80.0 * xrat;
	drect1.d_ur.d_y = O_y + 96.0 * yrat;

	drecttx.d_ll.d_x = O_x + 1.06 * xrat;
	drecttx.d_ll.d_y = O_y + 0.0 * yrat;
	drecttx.d_ur.d_x = O_x + 80.0 * xrat;
	drecttx.d_ur.d_y = O_y + (ch_y + 0.005)* 100 * yrat;

	drectx.str_rec.str_size = 60;
	drectx.str_rec.str_posn = 1;
	drectx.str_rec.str_col = 200;

	p1->w_x = 0.18; p1->w_y = 0.97;
	s_tx_i(1);
	text(c[2], p1);

	comment(c[0], c[7], c[8], c[53]);

	showwrect(&wrect[0], 1);

	for (i = 0; i < 6; i++) showchoice(i+1, i);
	showchoice(15, 6);
	showchoice(17, 7);
	showchoice(18, 8);

	p_nr = 0;
	p2 = p1;
	ASS(fp, gkss->gk_txfp)
	s_fa_i(22);
	s_ch_ht(0.04);
	CALLOC(stringtx, char, 64, MAIN)

	attsel = FALSE;
	force = FALSE;
	frstforce = TRUE;
	lastattshown =0;
	colchange = 0;
/*
#ifndef PET_RUBBERBAND
	s_dev(7, 246.0);
#else
*/
	s_dev(7, 123.0);
/*
#endif
*/
	s_dev(8, 6.0);
	s_dev(9, 2.0);
	s_dev(10, 5.0);
	s_dev(11, 5.0);
	s_dev(12, 4.0);
	
	p1->w_x = 0.01;
	p1->w_y = wrect[0].w_ll.w_y - ch_y * 1.1;
	str="Current attributes";
	s_tx_i(1);
	flagslocal();
	text(str, p1);

	flagsglobal();
	lineatt();
	areaatt();
	markatt();
	textatt();
	
	loc_mode(wss_aed, 1, REQUEST, FALSE);
	drec0.loc_rec.loc_col = 0;
	drec2.loc_rec.loc_col = 0;

	sel_cntran(gkss->gk_ntran[1]);
	s_clip(FALSE);

	k = 0;/* k is number of norm. transf. viewport of
	       * last locator choice
	       */

	loc0.loc_pt.w_x = loc0.loc_pt.w_y = 0.0;
	loc0.loc_nt = gkss->gk_ntran[0];
	loctx.loc_pt.w_x = loctx.loc_pt.w_y = 0.0;
	loctx.loc_nt = gkss->gk_ntran[0];

	/********HERE STARTS THE MAIN LOOP *********************/

	do {
#ifdef PET_RUBBERBAND
	   if (k == 1) pet = 4;
#else
	   if (k == 1) pet = 2;
#endif
	   /*to test rubber band make pet = 4 if k==1
	    *and use only colours with index below 128
	    */
	   else	pet = 1;
	   init_loc(wss_aed, 1, &loc0, pet, &drect0, &drec0);
	   req_loc(wss_aed, 1, &loc0);

	   lastk = k;
	   k = 0;
	   while (loc0.loc_nt != gkss->gk_ntran[k]) k++;
	   switch (k) {
	   case (1): /*point inside drawing viewport */
	   	if (attsel) {
	   		if(p_nr) 
	   		  fadedots(p_nr, p1);
	   		p2 = p1;
	   		p_nr = 0;
	   		attsel = FALSE;
	   	}
	   	ASS(*p2 , loc0.loc_pt)
	   	if (force && p_nr) {
	   	 	transpose(p2, p2-1);
	   		ASS(loc0.loc_pt , *p2)
		}
	   	showdot(p2);
	   	p2++;
	   	p_nr++;
	   	break;
	   case (2): /*polyline******************/
	   	if (!attsel){
	   		if(p_nr < 2) 
	   		comment(c[3],c[0], c[0], c[0]);
	   		else {
	   		fadedots(p_nr, p1);
	   		if (p_nr >2 && force){
	   	 	  transpose(p2 - 1, p1);
	   	 	  transpose(p2 - 1, p2 - 2);
	   		}
	   		s_clip(TRUE);
	   		act_seg();
	   		polyline(p_nr, p1);
	   		deact_seg();
	   		s_clip(FALSE);
	   		p_nr = 0;
	   		p2 = p1;
	   		}
	   	}
	   	else	sh_pol_att();
	   	break;
	   case (3):/*fill area***********************/
	   	if (!attsel){
	   		if (p_nr < 3)
	   		comment(c[4], c[0], c[0], c[0]);
	   		else {
	   		fadedots(p_nr, p1);
	   		if (p_nr >2 && force){
	   	 	  transpose(p2 - 1, p1);
	   	 	  transpose(p2 - 1, p2 - 2);
	   		}
	   		s_clip(TRUE);
	   		act_seg();
	   		fillarea(p_nr, p1);
	   		deact_seg();
	   		s_clip(FALSE);
	   		p_nr = 0;
	   		p2 = p1;
	   		}
	   	}
	   	else	sh_fill_att();
	   	break;
	   case (4): /*polymark*/
	   	if (!attsel){
	   		if (p_nr == 0)
	   		comment(c[5], c[0], c[0], c[0]);
	   		else {
	   		fadedots(p_nr, p1);
	   		if ( force && p_nr >2){
	   	 	  transpose(p2 - 1, p1);
	   	 	  transpose(p2 - 1, p2 - 2);
	   		}
	   		s_clip(TRUE);
	   		act_seg();
	   		polymark(p_nr, p1);
	   		deact_seg();
	   		s_clip(FALSE);
	   		p_nr = 0;
	   		p2 = p1;
	   		}
	   	}
	   	else{
	   		sh_pom_att();
	   	}
	   	break;
	   case (5): /*text*/
	   	if (lastk != 7){
	   	 comment(c[9], c[54], c[0], c[0]);
	   	 do {
	   	   str = "";
	   	   s_tx_i(1);
	   	   flagslocal();
	   	   init_str(wss_aed,1,str,1,&drecttx,&drectx);
	   	   ok = req_str(wss_aed, 1 , stringtx);
	   	   init_loc(wss_aed,1,&loctx,2,&drect1,&drec2);
	   	   flagsglobal();
	   	   if (ok == TRUE && strlen(stringtx) != 0) {
	   		not_in = FALSE;
	   		while(!not_in) {
	   		   req_loc(wss_aed, 1, &loctx);
	   		   not_in =
	   		    coord_in_rect(&wrect[0],&loctx.loc_pt);
	   		}
	   		s_clip(TRUE);
	   		act_seg();
	   		text(stringtx, &loctx.loc_pt); 
	   		deact_seg();
	   		s_clip(FALSE);
	   	   }
	   	 } while (ok == TRUE && strlen(stringtx) != 0);
	   	 comment(c[6], c[0], c[0], c[0]);
	   	}
	   	else {
	   		sh_text_att();
	   	}
	   	break;
	   case (6): /*stop*/
	   	if (inq_state() == SGOP) {
	   	    closeg();
	   	    comment(c[10], c[0], c[11], c[0]);
	   	}
	   	else comment(c[1],c[11], c[0], c[0]);

	   	break;
	   case (7):/*****attribute setting******/
	   	comment(c[1], c[12], c[0], c[0]);

	   	attsel = TRUE;
	   	break;
	   case (8):/*colourselection*/
	   case(17):/*colour 0*/
	   	if (wss_aed->ws_wsd->wd_screen->s_colr) {
	   	/*wrong field to check for colour!*/
	   		if (k == 17) {
	   		   cx = 0;
	   		}
	   		else {
	   		   cx = 4;
	   		   ytmp = wrect[7].w_ll.w_y + dev[7];
	   		   while (ytmp < loc0.loc_pt.w_y) {
	   			ytmp += dev[7];
	   			cx++;
	   		   }
	   		}
	   		switch(lastattshown) {
	   		case(2):
	   			s_pl_ci(cx);
	   			lineatt();
	   			break;
	   		case(3):
	   			s_fa_ci(cx);
	   			areaatt();
	   			break;
	   		case(4):
	   			s_pm_ci(cx);
	   			markatt();
	   			break;
	   		case(5):
	   			s_tx_ci(cx);
	   			textatt();
	   			break;
	   		}
	   	}
	   	else	comment(c[13], c[0], c[0], c[0]);
	   	attsel = TRUE;
	   	break;
	   case (9):/*linetype*/
	   	lt = 5;
	   	ytmp = wrect[8].w_ll.w_y + dev[8];
	   	while(ytmp < loc0.loc_pt.w_y){
	   		ytmp += dev[8];
	   		lt--;
	   	}
	   	s_lt(lt);
	   	lineatt();
	   	attsel = TRUE;
	   	break;
	   case (10):/*areatype*/
	   	i = 0;
	   	ytmp = wrect[9].w_ll.w_y + dev[9];
	   	while(ytmp < loc0.loc_pt.w_y) {
	   		ytmp += dev[10];
	   		i++;
	   	}
	   	if (i) s_fa_is(HOLLOW);
	   	else	s_fa_is(SOLID);
	   	areaatt();
	   	attsel = TRUE;
	   	break;
	   case (11):/*markertype*/
	   	i = 5;
	   	ytmp = wrect[10].w_ll.w_y + dev[10];
	   	while(ytmp < loc0.loc_pt.w_y) {
	   		ytmp += dev[10];
	   		i--;
	   	}
	   	s_mt((Mtype)i);
	   	markatt();
	   	attsel = TRUE;
	   	break;
	   case (12):/*markersize*/
	   	rat = s_raty(&loc0.loc_pt, 11);
	   	showsize(&wrect[11], rat);

	   	s_msz((Msize)(5.0 * rat));
	   	markatt();
	   	attsel = TRUE;
	   	break;
	   case (13):/*font*/
	   	i = 4;
	   	ytmp = wrect[12].w_ll.w_y + dev[12];
	   	while(ytmp < loc0.loc_pt.w_y) {
	   		ytmp += dev[12];
	   		i--;
	   	}
	   	if (i == 4) i = 8;
	   	/*stare is font 8, not 4*/
	   	fp.fp_fo = i;
	   	s_tx_fp(fp);
	   	textatt();
	   	attsel = TRUE;
	   	break;
	   case (14):/*width*/
	   	rat = (loc0.loc_pt.w_x - wrect[13].w_ll.w_x)/
	   	  (wrect[13].w_ur.w_x - wrect[13].w_ll.w_x);
	   	s_ch_ef((Charef)(2.0 * rat));
	   	showsize(&wrect[13], rat);
	   	textatt();
	   	attsel = TRUE;
	   	break;
	   case (15):/*height*/
	   	rat = s_raty(&loc0.loc_pt, 14);
	   	s_ch_ht((Charht)(rat * 0.08));

	   	showsize(&wrect[14], rat);
	   	textatt();
	   	attsel = TRUE;
	   	break;
	   case (28):/*text precision*****************************/
	   	if (fp.fp_pr == STR) {
	   		fp.fp_pr = CHAR;
	   		str = c[47]; 
	   		s_tx_fp(fp);
	   		showupvector(TRUE);
	   	}
	   	else  { fp.fp_pr = STR;
	   		s_tx_fp(fp);
	   		str = c[48]; 
	   		showupvector(FALSE);
	   	}
	   	comment(c[14], str, c[0], c[0]);
	   	attsel = TRUE;
	   	break;
	   case (29):/*character up vector************************/
	   	comment(c[15], c[16], c[17], c[0]);
	   	not_in = FALSE;
	   	while (not_in == FALSE) {
	   		req_loc(wss_aed, 1, &loc0);
	   		ASS(p_tr0 , loc0.loc_pt)
	   		req_loc(wss_aed, 1, &loc0);
	   		ASS(p_tr1 , loc0.loc_pt)
	   		p_tr1.w_x -= p_tr0.w_x;
	   		p_tr1.w_y -= p_tr0.w_y;
	   		if (p_tr1.w_x == p_tr0.w_x &&
	   		    p_tr1.w_y == p_tr0.w_y) 
	   		    comment(c[18], c[0], c[0], c[0]);
	   		else not_in = TRUE;
	   	}
	   	s_ch_up(&p_tr1);
	   	if (fp.fp_pr == CHAR) showupvector(TRUE);
	   	attsel = TRUE;
	   	break;
	   case (16) : /*clear*/
	   	fadearea(&wrect[0],0);
	   	showwrect(&wrect[0], 1);
	   	break;
	   case (18):/*force hor and ver lines */
	   	if (frstforce) {
	   	  frstforce = FALSE;
	   	  comment(c[19], c[20], c[21], c[6]);
	   	  force = TRUE;
	   	}
	   	else
	   	if (force) {
	   		force = FALSE;
	   		comment(c[22], c[6], c[0], c[0]);
	   	}
	   	else {
	   		force = TRUE;
	   		comment(c[23], c[6], c[0], c[0]);
	   	}
	   	break;
	   case (19) :/*segment handling *************************/
	   	for (i = 20; i <= 27; i++)
	     	   s_vip(gkss->gk_ntran[i], gkss->gk_ntran[1], TRUE);
	   	fadearea(&wrectur,0);
	   	for (i = 19; i <= 26; i++) showchoice(i, i);

	   	ul = FALSE; /* an eventually available
	   			underline is erased*/
	   	break;

	   case (20) : /*goon drawing ************************/
	   	for (i = 20; i <= 27; i++)
	     	     s_vip(gkss->gk_ntran[i], gkss->gk_ntran[0], TRUE);
	   	fadearea(&wrectur,0);
	   	for (i = 0; i < 6; i++) showchoice(i+1, i);
	   	showchoice(15, 6);
	   	showchoice(17, 7);
	   	showchoice(18, 8);

	   	ul = FALSE; /* an eventually underline is erased*/
	   	break;

	   case (21) : /* open segment  */
	   	case21();
	   	break;
	   case (22) : /*  close segment */
	   	case22();
	   	break;

	   case (23) : /* redraw all segments on ws*/
	   	s_w_wind(wss_aed,&nrect[0]);
	   	s_w_view(wss_aed,&drect1);
	   	update(wss_aed);
	   	redraw(wss_aed);
	   	s_w_wind(wss_aed,&nunit);
	   	s_w_view(wss_aed,&drect0);
	   	flagsglobal();
	   	showwrect(&wrect[0], 1);
	   	for (i = 19; i <= 26; i++) showchoice(i, i);
	   	lineatt();
	   	areaatt();
	   	markatt();
	   	textatt();
	   	showupvector(TRUE);

	   	lastattshown = 0;
	   	break;

	   case (24) : /* set visibility  ****************************/
	   	comment(c[29], c[30], c[0], c[0]);
	   	ask_sn(&segnm);
	   	si = wss_aed->ws_segs;
	   	while (si != NULL && si->si_this->sg_sn != segnm)
	   		si = si->si_next;
	   	if (si == NULL) 
	   		comment(c[31], c[0], c[0], c[0]);
	   	else {
	   		if (si->si_this->sg_vis == TRUE) {
	   			s_segvis(si->si_this, FALSE);
	   			str = c[52];
	   		}
	   		else {
	   			s_segvis(si->si_this, TRUE);
	   			str = c[51];
	   		}
	   		sprintf(strchar, "%s %d %s.", c[50], segnm,str);
	   		comment(strchar,c[6], c[0], c[0]);
	   	}

	   	break;

	   case (25) : /*set seg priority  ****************************/
	   	comment(c[32], c[30], c[0], c[0]);
	   	ask_sn(&segnm);
	   	si = wss_aed->ws_segs;
	   	while (si != NULL && si->si_this->sg_sn != segnm)
	   		si = si->si_next;
	   	if (si == NULL) {
	   	    comment(c[31], c[0], c[0], c[0]);
	   	}
	   	else {
	   		comment(c[33], c[0], c[0], c[0]);
	   		valprio = (Value)si->si_this->sg_pri;
	   		drecpri.val_rec.val_max = 1.0;
	   		drecpri.val_rec.val_min = 0.0;
	   		drecpri.val_rec.val_col = 200;
	   		init_val(wss_aed, 1, &valprio, 3,
	   			&drecttx, &drecpri);
	   		req_val(wss_aed, 1, &valprio);
	   		s_segpri(si->si_this, (Segpri)valprio);
	   		sprintf(strchar,"prio of segment %d is %2.2f",
	   			segnm, valprio);
	   		comment(strchar, c[6], c[0], c[0]);
	   	}

	   	break;
	   case (26): /*set segment transformation **************/
	   	comment(c[34], c[30], c[0], c[0]);
	   	ask_sn(&segnm);
	   	si = wss_aed->ws_segs;
	   	while (si != NULL && si->si_this->sg_sn != segnm)
	   		si = si->si_next;
	   	if (si == NULL) comment(c[31], c[0], c[0], c[0]);
	   	else {
	   	   comment(c[35], c[36], c[37], c[38]);
	   	   req_loc(wss_aed, 1, &loc0);
	   	   ASS(p_tr0 , loc0.loc_pt)
	   	   req_loc(wss_aed, 1, &loc0);
	   	   ASS(p_tr1 , loc0.loc_pt)
	   	   comment(c[39], c[0], c[0], c[0]);
	   	   scalef = si->si_this->sg_mat[0][0];
	   	   drecpri.val_rec.val_max = 100.0;
	   	   drecpri.val_rec.val_min = 0.0;
	   	   drecpri.val_rec.val_col = 200;
	   	   init_val(wss_aed, 1, &scalef, 3, &drecttx, &drecpri);
	   	   req_val(wss_aed, 1, &scalef);
	   	   sprintf(strchar,
	   	   	"scalefactor of segment %d is %3.2f", 
	   		segnm, scalef);
	   	   sg_mat[0][0] = scalef;
	   	   sg_mat[0][1] = 0.0;
	   	   sg_mat[0][2] = p_tr1.w_x - p_tr0.w_x;
	   	   sg_mat[1][0] = 0.0;
	   	   sg_mat[1][1] = scalef;
	   	   sg_mat[1][2] = p_tr1.w_y - p_tr0.w_y;
	   	   transeg(si->si_this, (Tmat *)&sg_mat[0][0]);
	   	   comment(strchar, c[6], c[0], c[0]);
	   	}
	   	break;
	   case (27):/*pick device*********************************/
	   	case27();
	   	break;
	   }
	} while (k != 6);

	FREE(p1)
	FREE(stringtx)
	deactivate(wss_aed);
	close_ws(wss_aed);
	close_gks();
}
