#include "cgksincl.h"

extern	double fabs();

typedef struct symb {
	Wc	s_b, s_e, s_o;
	Int	s_type;
	struct symb *s_next;
	} Symbol;

extern Symbol *firstsym, *lastsym;

extern GksState	gkstate;
extern	Gks	*gkss;
extern	Gksi	*gksis;
	Bool	coord_in_rect();
extern 	Wss	*wss_aed;
extern  Int 	ii, j, k, l;
extern	Wc	*p1, *p2 ;
extern	Real	ch_y;
extern	Wc	pc1, pc2, pc3, pc4;
extern  Wc		beginp, endp;
extern	Wrect	wrect[16];
extern	Wrect	wrect4 ;

extern	Msize ms;
	Wc s1[] = { -0.03,  0.00,
			-0.01,  0.00,
			-0.01,  0.02,
			-0.01, -0.02,
			 0.03,  0.00,
			 0.01,  0.00,
			 0.01,  0.01,
		     0.01, -0.01};
	Wc s2[] = { -0.03,  0.00,
			-0.01,  0.00,
			-0.01,  0.02,
			 0.01,  0.00,
			 0.03,  0.00,
			 0.01,  0.00,
			-0.01, -0.02,
			-0.01,  0.02,
			 0.01,  0.02,
			 0.01, -0.02};
	Wc s3[]=  { -0.03,  0.00,
			-0.02,  0.00,
			-0.0166, 0.018,
			-0.0100,-0.018,
			-0.0033, 0.018,
			 0.0033,-0.018,
			 0.0100, 0.018,
			 0.0167,-0.018,
			 0.02,  0.00,
			 0.03,  0.00};


flagson()
{
	s_asflags(017777);
}

flagsoff()
{
	s_asflags(0);
}

showdot(p2)
Wc	*p2;
{
	flagsoff();
	s_pm_i(1);
	polymark(1, p2);
	flagson();
}

fadedots(n, p1)
Size 	n;
Wc	*p1;
{
	s_pm_i(0);
	flagsoff();
	polymark(n, p1);
	flagson();
}


comment(str1,str2, str3,str4)
String str1, str2, str3, str4;
{
	s_tx_i(1);
	if(strlen(str1)) {
		fadearea(&wrect4, 0);
		flagsoff();
		text(str1, &pc1);
	}
	flagsoff();
	if (strlen(str2))  text(str2, &pc2);
	if (strlen(str3))  text(str3, &pc3);
	if (strlen(str4))  text(str4, &pc4);
	flagson();
}

Bool coord_in_rect(wrect, wc)
Wrect	*wrect;
Wc	*wc;
{	
	return  (Bool) ((wc->w_x >= wrect->w_ll.w_x) &&
		    (wc->w_y >= wrect->w_ll.w_y) &&
		    (wc->w_x <= wrect->w_ur.w_x) &&
		    (wc->w_y <= wrect->w_ur.w_y)
		   ); 
}

showwrect(wr, index)
Wrect	*wr;
Bindex	index;
{
	Wc	p[4], *ptr;
	ptr = &p[0];
	ptr->w_x = wr->w_ll.w_x; 
	ptr->w_y = wr->w_ll.w_y; ptr++;
	ptr->w_x = wr->w_ll.w_x; ptr->w_y = wr->w_ur.w_y; ptr++;
	ptr->w_x = wr->w_ur.w_x;
	ptr->w_y = wr->w_ur.w_y; ptr++;
	ptr->w_x = wr->w_ur.w_x; ptr->w_y = wr->w_ll.w_y;
	s_fa_i(index);
	flagsoff();
	fillarea(4, &p[0]);
 	flagson();
}

fadearea(wrect, is)
Wrect	*wrect;
Int	is;
{	
	showwrect(wrect, is);
}




turnp(p, s, p0, turn)
Wc *p, *s, *p0;
Int turn;
{
	Real x, y, coss, sinn;
	x = s->w_x; y = s->w_y;
	switch(turn) {
		case 0 : coss = 1.0; sinn = 0.0; break;
		case 1 : coss = 0.0; sinn = 1.0; break;
		case 2 : coss = -1.0; sinn = 0.0; break;
		case 3 : coss = 0.0; sinn = -1.0; break;
	}
	p->w_x = p0->w_x + x * coss - y * sinn;
	p->w_y = p0->w_y + x * sinn + y * coss;
}

symb1(p0, turn)
Wc	*p0;
Int	turn;
{	Wc p[8];	
	Int ii;
	for (ii=0; ii < 8; ii++) turnp(&p[ii], &s1[ii], p0, turn);
	polyline(4, &p[0]);
	polyline(4, &p[4]);
	ASS(beginp, p[0])
	ASS(endp, p[4])
}

symb2(p0, turn)
Wc	*p0;
Int	turn;
{	 Wc p[10];	
	Int ii;
	for (ii=0; ii < 8; ii++) turnp(&p[ii], &s2[ii], p0, turn);
	polyline(8, &p[0]);
	for (ii=8; ii < 10; ii++) turnp(&p[ii], &s2[ii], p0, turn);
	polyline(2, &p[8]);
	ASS(beginp, p[0])
	ASS(endp, p[4])
}

symb3(p0, turn)
Wc	*p0;
Int	turn;
{	Wc p[10];	
	Int ii;
	for (ii=0; ii < 10; ii++) turnp(&p[ii], &s3[ii], p0, turn);
	polyline(10, &p[0]);
	ASS(beginp, p[0])
	ASS(endp, p[9])
}

Bool connpt(pt)
Wc	*pt;
{	
	Symbol *sb;
	Bool found = FALSE;
	sb = firstsym;
	while ((found == FALSE) && (sb != NULL)) {
		if (( fabs(pt->w_x - sb->s_b.w_x) < 0.03) &&
			( fabs(pt->w_y - sb->s_b.w_y) < 0.03)) {
				pt->w_x = sb->s_b.w_x;
				pt->w_y = sb->s_b.w_y;
				found = TRUE;
		}
		else
		if (( fabs(pt->w_x - sb->s_e.w_x) < 0.03) &&
			( fabs(pt->w_y - sb->s_e.w_y) < 0.03)) {
				pt->w_x = sb->s_e.w_x;
				pt->w_y = sb->s_e.w_y;
				found = TRUE;
		}
		else 	sb = sb->s_next;
	}

	if (!found) {
		/*
		comment (" ","You din't point at an endpoint",
			"of a symbol","");
		*/
		return(FALSE);
	}
	else return(TRUE);
}

adapt(p)
Wc	*p;
{	
	Wc *prev ;	
	prev = p - 1;
	if ((p->w_x != prev->w_x) &&(fabs(p->w_y - prev->w_y)
		/ fabs(p->w_x - prev->w_x)) < 0.1) { 
		p->w_y = prev->w_y;
	}
	else if ((p->w_y != prev->w_y) &&(fabs(p->w_x - prev->w_x)
		/ fabs(p->w_y - prev->w_y)) < 0.1) { 
		p->w_x = prev->w_x;
	}
}
