/* @(#) activate.c  version:1.10  dated:84/11/20 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.activate.c
 * SCCS id :	activate.c 1.10
 * Last edited:	10/19/84 14:10:53
 *
 * Author:	Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */


 /*
  * This file contains the GKS functions 
  * ACTIVATE WORKSTATION, DEACTIVATE WORKSTATION.
  * locally used functions are definded in activatei.h
  */

#define GKS1
#define GKS 1

#include "cgksincl.h"

extern GksState	gkstate;
extern Gks	*_gkss;
extern Gksd	*gksd;
extern Gksi	*gksis;

#include "activatei.h"

activate(ws)
Wss *ws;
{	Int i;

	Ch_State(6, AC_WS);
	Ch_Er_Ws(ws, 2, AC_WS);

	if (ws->ws_actv == TRUE) Rep_Er(29, AC_WS);
	ws->ws_actv = TRUE;

	/*
	 * find a Wss pointer in the global statelist still
	 * pointing to nothing:
	 */
	i = 0;
	while (i < gksd->gd_nactv && _gkss->gk_actv[i] != NULL)  
		i++;
	/*
	 *at this point a test must be added to see 
	 *if i == gksd->gd_nactv .
	 *however gks 7.2 gives no errornumber in case all pointers
	 *are already taken
	 */
	_gkss->gk_actv[i] = ws;

	gkstate = WSAC;

#ifdef METAFILE
	if (ws->ws_wsd->wd_cat == MO)
/* all the current primitive attributes are routed to the metafile: */
		mo_atts(ws);
#endif

	return(0);
}

deactivate(ws)
Wss	*ws;
{
	Int	i;
	Int	nactv = gksd->gd_nactv;

	Ch_State(3, DA_WS);
	Ch_Er_Ws(ws, 2, DA_WS);
	if (ws->ws_actv == FALSE) Rep_Er(30, DA_WS)

	/* find the ws pointer in the global statelist:*/
	i = 0;
	while (i < nactv && _gkss->gk_actv[i] != ws) i++;

	/* if (i == nactv) then ws was not within the list of
	 * active workstations.
	 */
	if (i == nactv) Rep_Er(20, DA_WS)

	ws->ws_actv = FALSE;

	/*
	 * now shift remaining active workstations to the 'left' :
	 * (the code presumes that the last index is always NULL)
	 */
	do {
		_gkss->gk_actv[i] = _gkss->gk_actv[i + 1]; 
	} while (_gkss->gk_actv[i++] != NULL);

	if (_gkss->gk_actv[0] == NULL) gkstate = WSOP;
	return(0);
}
