/* @(#) aed512.c  version:1.21  dated:84/11/21 */
/*
 * C-GKS
 *
 * COPYRIGHT 1984 - CENTRUM VOOR WISKUNDE EN INFORMATICA
 */

/*
 * SCCS file:	SCCS/s.aed512.c
 * SCCS id :	aed512.c 1.21
 * Last edited:	11/21/84 14:19:07
 *
 * Author:	David Rosenthal, Behr de Ruiter, Paul ten Hagen
 *         	Centrum voor Wiskunde en Informatica
 *         	Amsterdam
 */


#define	TRMTYP	512

#include	"cgksincl.h"
#include	<signal.h>

#ifdef vax
#include	<ctype.h>
#include	<errno.h>
#else 
#define EINTR 4
extern	char	_ctype_[];
#define	isdigit(c)	((_ctype_+1)[c]&04)
#endif

#include	<sgtty.h>
#include	<setjmp.h>

#include	"aedtcp.h"
#include	"defns.h"
#include	"aed512.h"

STATIC int	cursor(), keyboard();
STATIC Bool	drawline(), drawhard(), drawmark(), gendrawpr();
STATIC Bool	aederase(), final();
STATIC Bool	setcolt();
STATIC Bool	aedescape();
Bool		aedrle();
STATIC Bool	aedpixelstream();
STATIC Bool	rectan(), setcol();
STATIC Bool	inqpixels();
STATIC Bool	setlatt(), setmatt(), settatt(), setfatt();
STATIC Bool	hilight(), aedmessage();
STATIC Bool	cells();
#ifdef HIGH_INPUT
STATIC Bool	aedidevice(), aedimode();
STATIC Bool	aedlocator(), aedvaluator(), aedchoice();
STATIC Bool	aedstring(), aedstroke(), aedpick();
#endif

/*Screen	g_aed512[] = {*/
Screen	g_aed512[1] = {
	MAXX, MAXY,	/* Main screen size */
	CHARX, CHARY,	/* Hard character size */
	CHARHT,		/* Hard character height */
	0, 0,		/* Hit location */
	0,		/* s_code: Hit code */
	0,		/* Colour */
	S_CHANGED,	/* s_flag ; status */
	'\0',		/* s_timo */
	aederase,	/* Total erase ; open ws*/
	NULL,		/* No erase mode; use colour 0*/
	final,		/* close ws*/
	NULL,		/* set clipping rectangle */
	aedmessage,	/* treats a message from the GKS message fun */
	aedescape,	/* escape */

	drawline,	/* Line drawing */
	drawmark,	/* Marker */
	drawhard,	/* Hard characters */
	aedpixelstream,	/* Write horiz. run; either 1 or diff colors*/
	aedrle,		/* run length encoding */
	cells,		/* direct cellarray pipe*/
	gendrawpr,	/* general drawing primitive*/
	rectan,		/* No seperate rectangle erase; use colour 0*/

	setlatt,	/* Set polyline attributes*/
	setmatt,	/* Set polymark attributes*/
	settatt,	/* Set text attributes*/
	setfatt,	/* Set fill area attributes*/
	setcol,		/* Select Colour */
	setcolt,	/* Set Colour Table */
	inqpixels,	/* Inquire pixel, and inq pixel array */
/*for a simple device, with only request input:*/
#ifndef	HIGH_INPUT 
	cursor,		/* Input from cursor */
	keyboard,	/* Input from keyboard */
#else
	aedidevice,	/*init input device*/
	aedimode,	/*set input device mode*/
	aedlocator,	/*get req. or sample input from loc dev */
	aedvaluator,	/*get req. or sample input from val dev */
	aedchoice,	/*get req. or sample input from cho dev */
	aedstring,	/*get req. or sample input from str dev */
	aedstroke,	/*get req. or sample input from stke dev */
	aedpick,	/*get req. or sample input from pick dev */
	NULL,		/*await event*/
#endif
	hilight,	/* hilite output primitive*/
	} ;

Screen *aedscrn = g_aed512;

/* the functionname aed512, being a possible candidate for
 * the workstation type parameter in open_ws(), is defined here to force
 * the inclusion of aed512.o in the object code of the application:
 */
int
aed512()
{	return(inst_scr("aed", aedscrn));
}

#include	"aedraw.h"
#include	"aedpmk.h"
#include	"aedfar.h"
#include	"aedpix.h"
#include	"aedcel.h"
#include 	"aedgdp.h"
#include 	"aedatt.h"
#include 	"aedhili.h"
#include 	"aedmsg.h"
#include 	"aedesc.h"

#include	"aedinp.h"
#ifdef HIGH_INPUT
#include	"aedhinp.h" /*high level input functions*/
#endif
