/* @(#) aedraw.h  version:1.11  dated:84/11/21 */
/*
 * SCCS file:	SCCS/s.aedraw.h
 * SCCS id :	aedraw.h 1.11
 * Last edited:	11/21/84 14:18:46
 */

	/* This file contains the basic AED 512 routines
	 * for drawing in screen space 
	 */



Bool atbeam();

File *AedOUT;
File *AedIN;
	/*these filepointers are global to all aed workstations;
	 *and will be changed at each call of the driverfunctions
	 *to point to wanted aed workstation 
	 */

/*CREAT_INP is (eventually) defined in cgkslocal.h
 *If set a file `aedinput' is created containing the characters 
 *received from the workstation.
 *With this file it is possible to repeat a session (by
 *saying for example: app < aedinput > stdout  )
 */

/*#define	SLOWER	/* To turn off buffering */

STATIC
Printf(fmt,a1,a2)
char	*fmt;
Int	a1,a2;
{
	fprintf(AedOUT,fmt,a1,a2);
}

#undef 	putchar
#define	putchar(X)	fputc(X,AedOUT);

#define	command	putchar
#define	prefix	putchar

#ifdef 	CREAT_INP
File	*aedinpfp = NULL;
#endif


struct sgttyb aedttyb;
struct sgttyb aedttyb2;
static char	dotted	= '\252';
static char	dashed	= '\335';
static char	dotdash	= '\327';
STATIC Ic	beam = { 0, 0 };
/*
static Bool	graphmode = FALSE;
*/
Bool	graphmode = FALSE;
/*
static int	background = 0;
static int	foreground = 1;
*/
STATIC Pet	curpet = 0;



#define Set_Out(ofile) AedOUT = ofile;
#define Set_In(ifile) AedIN = ifile;

/* Draw polyline in screen space 
 * Linepieces already clipped 
 */
static Bool
drawline(ws, n, s, ltype, lwidth)
Wss	*ws;
Int	n;
Ic	*s;
Ltype	ltype;
Lwidth	lwidth;	/*not yet interpreted*/
{
	Ic	*s1, s3[2];
	Int 	m = n;

	Set_Out(ws->ws_ofile)
	setltyp(ltype);

	switch (ltype) {
	case DOUBLE:	/* N.B. not a good way of doing it */
	    	s1 = s;
		while (--m) {
			drawline(ws,2,s1,SOLIDL,lwidth);
			s3[0].i_x = (s1->i_x != 0) ? s1->i_x-1 : 0;
			s3[0].i_y = (s1->i_y != 0) ? s1->i_y-1 : 0;
			s3[1].i_x = ((s1 + 1)->i_x != 0) ? 
					(s1 + 1)->i_x-1 : 0;
			s3[1].i_y = ((s1 + 1)->i_y != 0) ?
					(s1 + 1)->i_y-1 : 0;
			drawline(ws,2,s3,SOLIDL, lwidth);
			s3[0].i_x += 2;
			s3[1].i_x += 2;
			drawline(ws,2,s3,SOLIDL, lwidth);
			s3[0].i_x = s1->i_x;
			s3[0].i_y += 2;
			s3[1].i_x = (s1 + 1)->i_x;
			s3[1].i_y += 2;
			drawline(ws,2,s3,SOLIDL, lwidth);
			s1++;
	    	}
		break;
	case DOTTED:
	case DASHED:
	case DOTDASH:
	case SOLIDL:
		if (n == 2) { /*only 1 linepiece */
			if (graphmode && atbeam(s)) { 
				lineto(s + 1);
			}
			else if(graphmode && atbeam(s + 1)) {
				lineto(s);
			}
			else {
				moveto(s);
				lineto(s + 1);
			}
		}
		else {
			if (graphmode == FALSE || (atbeam(s) == FALSE))
				moveto(s);
			/*now draw m-1 vectors relative*/

			/*AedDMV doesn't work:
			command(AedDMV);
			while (--m != 0) relcoord(s, s++ + 1);
			relcoord(s, s); 0,0 to terminate AedDMV
			ASS(beam, *s)
			*/

			while (--m != 0)
				lineto(++s);
		}
		break;
	}
	prefix(ESC);
	graphmode = TRUE;
}

static Bool
drawhard(ws, s, ic)	/* Draw hard char str s at ic in screen space */
Wss	*ws;
String	s;
Ic 	*ic;
{
	register char c;
	char *s2 = s;
	Screen *sc = WsScrn;

	Set_Out(ws->ws_ofile)
	if (!atbeam(ic) || graphmode) {
		moveto(ic);
	}
	if (graphmode) alphamode();
	ASS(beam, *ic)
	while((c = *s2++) != '\0') {
		if (c > US) {
			putchar(c);
			beam.i_x += sc->s_chsz.i_x;
		}
	}
	prefix(ESC);
	graphmode = TRUE;
}

static
sigint()
{
	out_msg("\ninterrupt via SIGINT");
}



static
initial()
{
#ifdef	SLOWER
	setbuf(AedOUT,(char *) NULL);
#endif
	setbuf(AedIN,(char *) NULL);
#ifdef	TIOCSETA
	ioctl(fileno(AedOUT), TIOCGETA, &aedttyb);
	ioctl(fileno(AedOUT), TIOCGETA, &aedttyb2);
#else
	/* not set*/
	ioctl(fileno(AedOUT), TIOCGETP, &aedttyb);
	ioctl(fileno(AedOUT), TIOCGETP, &aedttyb2);
#endif
#ifdef	TIOCSETA
	aedttyb.sg_width = 0;
	aedttyb.sg_length = 0;
	aedttyb.sg_crdly = 0;
	aedttyb.sg_nldly = 0;
#endif	TIOCSETA
	aedttyb.sg_flags &= ~ECHO;
#ifndef	NOMODES
	aedttyb.sg_flags |= (CBREAK|ODDP|EVENP|TANDEM);
	aedttyb.sg_flags &= ~ALLDELAY;
#endif
#ifdef	TIOCSETA
	ioctl(fileno(AedOUT),TIOCSETA,&aedttyb);
#else
	ioctl(fileno(AedOUT),TIOCSETP,&aedttyb);
#endif	TIOCSETA
	signal(SIGINT, sigint);

	prefix(ESC);
	command(AedSEN);
	putchar('1');	/* Abbreviated fn codes */
#if	(CODE == 7)
	putchar('7');	/* 7-bit encoding */
	putchar('7');
	putchar('7');
	putchar('7');
#endif
#if	(CODE == 1)
	putchar('D');
	putchar('D');
	putchar('D');
	putchar('N');
#endif
#if	(CODE == 8)
	putchar('8');
	putchar('8');
	putchar('8');
	putchar('8');
#endif
}

static Bool	inited = FALSE;

static Bool
final(ws)
Wss *ws;
{
	Set_Out(ws->ws_ofile)
#ifdef	TIOCSETA
	ioctl(fileno(AedOUT), TIOCSETA, &aedttyb2);
#else
	ioctl(fileno(AedOUT), TIOCSETP, &aedttyb2);
#endif
	inited = FALSE;
}

STATIC
flush(i)
int	i;
{
	while (i--)
		putchar('\0');
		/*fputc(AedOUT, '\0');*/
/*	ioctl(fileno(AedOUT),TIOCFLUSH,(struct sgttyb *) NULL); */
}

STATIC Bool
atbeam(s)
Ic	*s;
{
	return (Bool) ((s->i_x == beam.i_x) && (s->i_y == beam.i_y));
}

/*
 * Transmit AED Abs coordinate.
 */
STATIC
abscoord(s)
Ic	*s;
{
#if 	(CODE == 7 || CODE == 8)
	register unsigned	c;
#endif

#if	(CODE == 7)
	c = (s->i_x & HI_MASK) >> 3;
	c |= (s->i_y & HI_MASK) >> 7;
	putchar(c&MASK7);
	putchar(s->i_x & LO_MASK);
	putchar(s->i_y & LO_MASK);
#endif
#if	(CODE == 8)
	c = (s->i_x & HI_MASK) >> 4;
	c |= (s->i_y & HI_MASK) >> 8;
	putchar(c);
	putchar(s->i_x & LO_MASK);
	putchar(s->i_y & LO_MASK);
#endif
#if	(CODE == 1)
	fprintf(AedOUT,"%d %d ",s->i_x,s->i_y);
#endif
	ASS(beam , *s)
}

/*
 *Transmit Aed relative coordinate
 */
STATIC
relcoord (s1, s2)
Ic	*s1, *s2;
{	fprintf(AedOUT, "%d %d ", (int)s2->i_x - (int)s1->i_x,
				  (int)s2->i_y - (int)s1->i_y);
	/*ASS(beam, *s) is done after all relative moves*/
}

/*
 * Send a value8
 */
STATIC
value8(x)
int	x;
{
#if	(CODE == 7)
	putchar((x & LO_MASK) >> 7);
	putchar(x & LO_MASK);
#endif
#if	(CODE == 8)
	putchar(x & LO_MASK); /* MASK8 iso LO_MASK  ? */
#endif
#if	(CODE == 1)
	fprintf(AedOUT,"%d ",x&MASK8);
#endif
}

/*
 * Send a 16 bit value
 */
static
value16(x)
Int	x;
{
#if	(CODE == 7)
	putchar((x >> 7) & MASK7);
	putchar(x & MASK7);
#endif
#if	(CODE == 8)
	putchar((x >> 8) & LO_MASK);
	putchar(x & LO_MASK);
#endif
#if	(CODE == 1)
	Printf("%d ",x&MASK16);
#endif
}

/* Send a varaiable length operand
 */

STATIC
valuev(x)
int	x;
{
#if 	(CODE == 7)
	;
#endif
#if	(CODE == 8)
	;
#endif
#if	(CODE == 1)
	Printf("%d ", x);
#endif
}

/*
 * Get into Alpha mode at CAP
 */
STATIC
alphamode()
{
	putchar(SOH);
	beam.i_y = beam.i_x = 0;
	graphmode = FALSE;
}

/*
 * Get into graph mode with CAP at *s
 */
STATIC
moveto(s)
Ic	*s;
{
	if (graphmode == FALSE) {
		alphamode();
		prefix(ESC);
	}
	command(AedMOV);
	abscoord(s);
	graphmode = TRUE;
}

/*
 * Line from CAP to *s
 */
STATIC
lineto(s)
Ic	*s;
{
	command(AedDVA);	/* Optimise later */
	abscoord(s);
}

/*
 * Erase screen
 */

STATIC
Bool
aederase(ws)
Wss	*ws;
{
	Set_In(ws->ws_ifile)
	Set_Out(ws->ws_ofile)
	if (inited == FALSE) {
#ifdef CREAT_INP
		aedinpfp = fopen("@aedinput", "w");
		if (aedinpfp != NULL) setbuf(aedinpfp, (char *)NULL);
#endif
		initial();
		prefix(ESC);
		command(AedSEC);
		value8((Int)WsScrn->s_ccol);

		inited = TRUE;
	}
	alphamode();
	prefix(ESC);
	command(AedERS);
	alphamode();
	flush(ERASED);
}

STATIC
Bool rectan(ws,ll,ur)
Wss	*ws;
Ic	*ll;
Ic	*ur;
{
	Set_Out(ws->ws_ofile)
	moveto(ll);
	prefix(ESC);
	command(AedDFR);
	abscoord(ur);
	ASS(beam, *ur)
	/*
	alphamode();
	*/
}
